#region Copyright Syncfusion Inc. 2001 - 2017
// Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion

namespace PivotGridDemo
{
    using System;
    using System.Collections;
    using System.Globalization;
    using System.Windows;
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            pivotGrid1.PivotColumns[0].Comparer = new WeekComparer();
            pivotGrid1.PivotColumns[1].Comparer = new DayComparer();
        }
    }

    public class DayComparer : IComparer
    {
        /// <summary>
        /// Compare for DateTime objects.
        /// </summary>
        /// <param name="x">object.</param>
        /// <param name="y">object.</param>
        /// <returns>integer</returns>
        public int Compare(object x, object y)
        {
            DateTime dummyX, dummyY;
            if (x == null && y == null)
                return 0;
            else if (y == null)
                return 1;
            else if (x == null)
                return -1;
            else if (DateTime.TryParseExact(x.ToString(), "dd", CultureInfo.InvariantCulture, DateTimeStyles.None,  out dummyX) && DateTime.TryParseExact(y.ToString(), "dd", CultureInfo.InvariantCulture, DateTimeStyles.None, out dummyY))
                return DateTime.Compare(dummyX.Date, dummyY.Date);
            else
                return 0;
        }
    }

    public class WeekComparer  :IComparer
    {
        /// <summary>
        /// Compare for DateTime objects.
        /// </summary>
        /// <param name="x">object.</param>
        /// <param name="y">object.</param>
        /// <returns>integer</returns>
        public int Compare(object x, object y)
        {
            int dt1 = (int)Enum.Parse(typeof(DayOfWeek), x.ToString());
            int dt2 = (int)Enum.Parse(typeof(DayOfWeek), y.ToString());
            if (x == null && y == null)
                return 0;
            else if (y == null)
                return 1;
            else if (x == null)
                return -1;
            else
                return dt1.CompareTo(dt2);
        }

       
    }
}
