#region Copyright Syncfusion Inc. 2001 - 2017
// Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion


namespace PivotGridDemo.Model
{
    using System;
    using System.Collections.Generic;
    internal class ProductSales
    {
        public string Catelogue { get; set; }

        public string Person { get; set; }

        public string Week { get; set; }

        public string Day { get; set; }

        public int Quantity { get; set; }

        public double Amount { get; set; }

        public double UnitPrice { get; set; }

        public string Client { get; set; }

        public static ProductSalesCollection GetSalesData()
        {
            DateTime dt = DateTime.Now;
            /// Geography
            string[] countries = new string[] { "Australia", "Canada", "France", "Germany", "United Kingdom", "United States" };
            string[] ausStates = new string[] { "New South Wales", "Queensland", "South Australia", "Tasmania", "Victoria" };
            string[] canadaStates = new string[] { "Alberta", "British Columbia", "Brunswick", "Manitoba", "Ontario", "Quebec" };
            string[] franceStates = new string[] { "Charente Maritime", "Essonne", "Garonne (Haute)", "Gers", };
            string[] germanyStates = new string[] { "Bayern", "Brandenburg", "Hamburg", "Hessen", "Nordrhein Westfalen", "Saarland" };
            string[] ukStates = new string[] { "England" };
            string[] ussStates = new string[] { "New York", "North Carolina", "Alabama", "California", "Colorado", "New Mexico", "South Carolina" };


            string[] dates = new string[] { "Person1", "Person2", "Person3" };

            string[] products = new string[] { "Cat1", "Cat2", "Cat3" };
            string[] clients = new string[] { "Cli1", "Cli2", "Cli3" };
            Random r = new Random(123345345);

            int numberOfRecords = 2000;
            ProductSalesCollection listOfProductSales = new ProductSalesCollection();
            for (int i = 0; i < numberOfRecords; i++)
            {
                ProductSales sales = new ProductSales();
                sales.Day = DateTime.Today.AddDays(r.Next(31)).ToString("dd");
                sales.Week = DateTime.Today.AddDays(r.Next(7)).ToString("dddd");
                sales.Quantity = r.Next(1, 12);
                /// 1 percent discount for 1 quantity
                double discount = (30000 * sales.Quantity) * (double.Parse(sales.Quantity.ToString()) / 100);
                sales.Amount = (30000 * sales.Quantity) - discount;
                sales.Client = clients[r.Next(r.Next(dates.GetLength(0) + 1))];
                //sales.UnitPrice = sales.Amount / sales.Quantity;
                sales.Person = dates[r.Next(r.Next(dates.GetLength(0) + 1))];
                sales.Catelogue = products[r.Next(r.Next(products.GetLength(0) + 1))];
                
                listOfProductSales.Add(sales);
            }

            return listOfProductSales;
        }

        public override string ToString()
        {
            return string.Format("{0}-{1}-{2}");
        }

        public class ProductSalesCollection : List<ProductSales>
        {
        }
    }
}
